
#include    "stdio.h"

unsigned short p_div(data, divisor, remainder)
unsigned short data;
unsigned short divisor;
unsigned short remainder;
{
    static unsigned short quotient, i;
    for (i = 8; i > 0; i--)
	{
	quotient = remainder & 0x8000;
	remainder <<= 1;
	if ((data << = 1) & 0x0100)
	    remainder |= 1;
	if (quotient)
	    remainder ^= divisor;
	printf("        ");
	putbin(remainder);	    /* display binary for each step	*/
	}
    return (remainder);
}

main()			    /* perform polynomial division on message	*/
{
    static char message[4] = {'C', 'f', 'y', 'U'};  /* from Chapter Three   */
    int i;
    unsigned short remainder = 0;	/* must initialize to zero	*/
    for (i = 0; i < 4; ++i)
	{
	remainder = p_div(message[i], 0x1021, remainder);   /* CCITT poly   */
	putbin(remainder);
	}
}
